<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: cipher_xtea/xtea_cipher.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_ff1a9937d77091a843a75ae52572ae76.html">cipher_xtea</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">xtea_cipher.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="xtea__cipher_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef XTEA_CIPHER_H</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define XTEA_CIPHER_H</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">//#define XTEA_CIPHER_HEADER_ONLY</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#ifdef XTEA_CIPHER_HEADER_ONLY</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#define XTEA_CIPHER_SPEC static inline</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="xtea__cipher_8h.html#a0df4b7af18ddd87e36ff0a8b157781ed">   26</a></span>&#160;<span class="preprocessor">#define XTEA_CIPHER_SPEC</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="structxtea__cbc__t.html">   31</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;{</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="structxtea__cbc__t.html#a480d35b2f56c96f12798b18562e7fdf5">   33</a></span>&#160;    uint32_t key[4];</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="structxtea__cbc__t.html#af486415b60e9011066054bfb89d80ece">   34</a></span>&#160;    uint32_t <a class="code" href="structxtea__cbc__t.html#af486415b60e9011066054bfb89d80ece">num_rounds</a>;</div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="structxtea__cbc__t.html#a60c76d5d348826af046b7cb6c4b4096b">   35</a></span>&#160;    uint32_t previous[2];</div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="structxtea__cbc__t.html#a2118d2d9795c4df320bd80b2cce61d4d">   36</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="structxtea__cbc__t.html#a2118d2d9795c4df320bd80b2cce61d4d">is_first</a>;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;} <a class="code" href="structxtea__cbc__t.html">xtea_cbc_t</a>;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<a class="code" href="xtea__cipher_8h.html#a0df4b7af18ddd87e36ff0a8b157781ed">XTEA_CIPHER_SPEC</a> <span class="keywordtype">void</span> <a class="code" href="xtea__cipher_8h.html#a6be7731806c1b0c5d0271d219882e0a5">xtea_cbc_init</a>(<a class="code" href="structxtea__cbc__t.html">xtea_cbc_t</a>* xtea_cbc,</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;                                    uint32_t init_vector[2], uint32_t key[4],</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;                                    uint32_t num_rounds);</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<a class="code" href="xtea__cipher_8h.html#a0df4b7af18ddd87e36ff0a8b157781ed">XTEA_CIPHER_SPEC</a> <span class="keywordtype">void</span> <a class="code" href="xtea__cipher_8h.html#a208d32f2e9e6e12c71b28206f020b8de">xtea_cbc_encrypt</a>(<a class="code" href="structxtea__cbc__t.html">xtea_cbc_t</a>* xtea_cbc,</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;                                       <span class="keyword">const</span> uint32_t clear[2],</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;                                       uint32_t encrypted[2]);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<a class="code" href="xtea__cipher_8h.html#a0df4b7af18ddd87e36ff0a8b157781ed">XTEA_CIPHER_SPEC</a> <span class="keywordtype">void</span> <a class="code" href="xtea__cipher_8h.html#a11eee4453fa9762f2e4ce9ff75ec95ff">xtea_cbc_decrypt</a>(<a class="code" href="structxtea__cbc__t.html">xtea_cbc_t</a>* xtea_cbc,</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;                                       <span class="keyword">const</span> uint32_t encrypted[2],</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                                       uint32_t clear[2]);</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<a class="code" href="xtea__cipher_8h.html#a0df4b7af18ddd87e36ff0a8b157781ed">XTEA_CIPHER_SPEC</a> <span class="keywordtype">void</span> <a class="code" href="xtea__cipher_8h.html#aba6847e42c4df4054a22a467391faa0c">xtea_encrypt_block</a>(<span class="keyword">const</span> uint32_t clear[2],</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;                                         <span class="keyword">const</span> uint32_t key[4],</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;                                         uint32_t encrypted[2],</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;                                         uint32_t num_rounds);</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<a class="code" href="xtea__cipher_8h.html#a0df4b7af18ddd87e36ff0a8b157781ed">XTEA_CIPHER_SPEC</a> <span class="keywordtype">void</span> <a class="code" href="xtea__cipher_8h.html#a88a3b96c29680cdd93110af84fc92f90">xtea_decrypt_block</a>(<span class="keyword">const</span> uint32_t encrypted[2],</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;                                         <span class="keyword">const</span> uint32_t key[4],</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;                                         uint32_t clear[2],</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;                                         uint32_t num_rounds);</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="preprocessor">#ifdef XTEA_CIPHER_HEADER_ONLY</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="xtea__cipher_8c.html">xtea_cipher.c</a>&quot;</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="xtea__cipher_8h_html_a88a3b96c29680cdd93110af84fc92f90"><div class="ttname"><a href="xtea__cipher_8h.html#a88a3b96c29680cdd93110af84fc92f90">xtea_decrypt_block</a></div><div class="ttdeci">XTEA_CIPHER_SPEC void xtea_decrypt_block(const uint32_t encrypted[2], const uint32_t key[4], uint32_t clear[2], uint32_t num_rounds)</div><div class="ttdef"><b>Definition:</b> xtea_cipher.c:72</div></div>
<div class="ttc" id="structxtea__cbc__t_html"><div class="ttname"><a href="structxtea__cbc__t.html">xtea_cbc_t</a></div><div class="ttdef"><b>Definition:</b> xtea_cipher.h:31</div></div>
<div class="ttc" id="xtea__cipher_8c_html"><div class="ttname"><a href="xtea__cipher_8c.html">xtea_cipher.c</a></div></div>
<div class="ttc" id="xtea__cipher_8h_html_a0df4b7af18ddd87e36ff0a8b157781ed"><div class="ttname"><a href="xtea__cipher_8h.html#a0df4b7af18ddd87e36ff0a8b157781ed">XTEA_CIPHER_SPEC</a></div><div class="ttdeci">#define XTEA_CIPHER_SPEC</div><div class="ttdef"><b>Definition:</b> xtea_cipher.h:26</div></div>
<div class="ttc" id="structxtea__cbc__t_html_a2118d2d9795c4df320bd80b2cce61d4d"><div class="ttname"><a href="structxtea__cbc__t.html#a2118d2d9795c4df320bd80b2cce61d4d">xtea_cbc_t::is_first</a></div><div class="ttdeci">int is_first</div><div class="ttdef"><b>Definition:</b> xtea_cipher.h:36</div></div>
<div class="ttc" id="xtea__cipher_8h_html_a208d32f2e9e6e12c71b28206f020b8de"><div class="ttname"><a href="xtea__cipher_8h.html#a208d32f2e9e6e12c71b28206f020b8de">xtea_cbc_encrypt</a></div><div class="ttdeci">XTEA_CIPHER_SPEC void xtea_cbc_encrypt(xtea_cbc_t *xtea_cbc, const uint32_t clear[2], uint32_t encrypted[2])</div><div class="ttdef"><b>Definition:</b> xtea_cipher.c:18</div></div>
<div class="ttc" id="xtea__cipher_8h_html_a11eee4453fa9762f2e4ce9ff75ec95ff"><div class="ttname"><a href="xtea__cipher_8h.html#a11eee4453fa9762f2e4ce9ff75ec95ff">xtea_cbc_decrypt</a></div><div class="ttdeci">XTEA_CIPHER_SPEC void xtea_cbc_decrypt(xtea_cbc_t *xtea_cbc, const uint32_t encrypted[2], uint32_t clear[2])</div><div class="ttdef"><b>Definition:</b> xtea_cipher.c:33</div></div>
<div class="ttc" id="xtea__cipher_8h_html_aba6847e42c4df4054a22a467391faa0c"><div class="ttname"><a href="xtea__cipher_8h.html#aba6847e42c4df4054a22a467391faa0c">xtea_encrypt_block</a></div><div class="ttdeci">XTEA_CIPHER_SPEC void xtea_encrypt_block(const uint32_t clear[2], const uint32_t key[4], uint32_t encrypted[2], uint32_t num_rounds)</div><div class="ttdef"><b>Definition:</b> xtea_cipher.c:48</div></div>
<div class="ttc" id="structxtea__cbc__t_html_af486415b60e9011066054bfb89d80ece"><div class="ttname"><a href="structxtea__cbc__t.html#af486415b60e9011066054bfb89d80ece">xtea_cbc_t::num_rounds</a></div><div class="ttdeci">uint32_t num_rounds</div><div class="ttdef"><b>Definition:</b> xtea_cipher.h:34</div></div>
<div class="ttc" id="xtea__cipher_8h_html_a6be7731806c1b0c5d0271d219882e0a5"><div class="ttname"><a href="xtea__cipher_8h.html#a6be7731806c1b0c5d0271d219882e0a5">xtea_cbc_init</a></div><div class="ttdeci">XTEA_CIPHER_SPEC void xtea_cbc_init(xtea_cbc_t *xtea_cbc, uint32_t init_vector[2], uint32_t key[4], uint32_t num_rounds)</div><div class="ttdef"><b>Definition:</b> xtea_cipher.c:5</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
